package net.lensfrex.disillusion.client.config;

import okhttp3.OkHttpClient;

import java.net.InetSocketAddress;
import java.net.Proxy;

public class Constants {
    public static final String tokenFile = "token";

    public static final String numberPattern = "^\\d+$";

//    public static final OkHttpClient globalClient = new OkHttpClient.Builder()
//            .proxy(new Proxy(Proxy.Type.HTTP, new InetSocketAddress("127.0.0.1", 8080)))
//            .build();

    public static final OkHttpClient globalClient = new OkHttpClient();

    public static final String SERVER_ADDRESS = "http://127.0.0.1:8888";
    public static final String BASE_URL = "/api";

    public static class UserRequestUrls {
        public static final String LOGIN_URL = SERVER_ADDRESS + BASE_URL + "/user/login";
        public static final String REGISTER_URL = SERVER_ADDRESS + BASE_URL + "/user/register";
        public static final String TOKEN_REFRESH_URL = SERVER_ADDRESS + BASE_URL + "/user/refresh";

        public static final String USER_INFO_EDIT_URL = SERVER_ADDRESS + BASE_URL + "/user/info/edit";
        public static final String USER_INFO_VIEW_URL = SERVER_ADDRESS + BASE_URL + "/user/info/view";

        public static final String USER_PUBLIC_INFO_VIEW_URL = SERVER_ADDRESS + BASE_URL + "/user/info/view/public";

        public static final String USER_AVATAR_VIEW_URL = SERVER_ADDRESS + BASE_URL + "/user/info/avatar";
        public static final String USER_AVATAR_EDIT_URL = SERVER_ADDRESS + BASE_URL + "/user/info/avatar/upload";
    }

    public static class ResumeRequestUrls {
        public static final String RESUME_UPLOAD_URL = SERVER_ADDRESS + BASE_URL + "/student/resume/add";
        public static final String RESUME_GET_ALL_URL = SERVER_ADDRESS + BASE_URL + "/student/resume/all";
        public static final String RESUME_DELETE_URL = SERVER_ADDRESS + BASE_URL + "/student/resume/delete";
        public static final String RESUME_FILE_URL = SERVER_ADDRESS + BASE_URL + "/student/resume/getFile";
        public static final String RESUME_UPDATE_URL = SERVER_ADDRESS + BASE_URL + "/student/resume/update";
        public static final String RESUME_VIEW_URL = SERVER_ADDRESS + BASE_URL + "/student/resume/view";
    }

    public static class ApplicationRequestUrls {
        public static final String APPLICATION_PUBLISH_URL = SERVER_ADDRESS + BASE_URL + "/student/application/publish";
        public static final String APPLICATION_DELETE_URL = SERVER_ADDRESS + BASE_URL + "/student/application/delete";
        public static final String APPLICATION_STUDENT_VIEW_URL = SERVER_ADDRESS + BASE_URL + "/student/application/view";

        public static final String APPLICATION_EMPLOYER_VIEW_URL = SERVER_ADDRESS + BASE_URL + "/employer/application/view";
        public static final String APPLICATION_DEAL_URL = SERVER_ADDRESS + BASE_URL + "/employer/application/deal";
    }

    public static class OfferRequestUrls {

        public static final String OFFER_FILTER_EMPLOYER = "by_employer";
        public static final String OFFER_FILTER_JOB_NAME = "by_job_name";
        public static final String OFFER_FILTER_SALARY = "by_salary";

        public static final String GET_ALL_OFFER_URL = SERVER_ADDRESS + BASE_URL + "/offer/getAll";
        public static final String GET_OFFER_URL = SERVER_ADDRESS + BASE_URL + "/offer/get";
        public static final String OFFER_PROGRESS_URL = SERVER_ADDRESS + BASE_URL + "/offer/progress";

        public static final String OFFER_GET_BY_EMPLOYER_SELF_URL = SERVER_ADDRESS + BASE_URL + "/employer/offer/view";
        public static final String OFFER_DELETE_URL = SERVER_ADDRESS + BASE_URL + "/employer/offer/delete";
        public static final String OFFER_PUBLISH_URL = SERVER_ADDRESS + BASE_URL + "/employer/offer/publish";
        public static final String OFFER_UPDATE_URL = SERVER_ADDRESS + BASE_URL + "/employer/offer/update";

        public static final String OFFER_SEARCH_URL = SERVER_ADDRESS + BASE_URL + "/offer/search";
    }

    public static final String USER_TYPE_STUDENT = "0";
    public static final String USER_TYPE_EMPLOYER = "1";

    public static final String sample = "  前期经过自愿报名并审核成功的学生，根据所报微专业的培养方案，自行选择相应课程。\n" +
            "\n" +
            "  9．认真对照培养方案，选课时务必仔细核对课程信息，确保“课程代码”、“课程名称”、“学分”这三项重要信息与培养方案要求相符。\n" +
            "\n" +
            "  10．禁止同一时间修读两门及以上课程，系统会提示时间冲突并禁止选课。提前了解专业教学进程（实习、实践、课程设计等）情况，不能选择与本专业其它教学任务周次有冲突的课堂。\n" +
            "\n" +
            "  11．因培养方案变动、转专业等原因，计划修读的课程确定不再开课的，请先查询本科生课程学分认定对照表并咨询开课学院，再进行选课。待课程修读完获得学分后，再按照本科生院发布的相关要求办理学分认定。\n" +
            "\n" +
            "  12．学生选课、听课、考核必须一致。学生不能参加未选择课程的学习和考核，即使参加了学习和考核，如果没有选课，也是无效的，将不记录成绩。\n" +
            "\n" +
            "  13．学生凭学号、密码选课，认真对待，并对自己的选课行为负责。密码必须妥善保管，不得代替他人选课，不得借用、盗用他人学号及密码选课。\n" +
            "\n" +
            "  14．学生登录本科教学综合管理系统需通过学校统一身份认证平台登录，登录方式、密码重置方式详见以下两个通知：https://jwc.wust.edu.cn/2022/0226/c1925a255654/page.htm、https://jwc.wust.edu.cn/2022/0302/c1925a255786/page.htm。";

    public static class Svg {
        public static final String deleteSvg = "M96 128h832v64H96zM128 256h768l-89.024 704H217.024z M384 64h256v96h-256z";

        public static final String sendSvg =
                "M1008 6.286q18.857 13.714 15.429 36.571l-146.286 877.714q-2.857 16.571-18.286 25.714-8 4.571-17.714 4.571-6.286 " +
                        "0-13.714-2.857l-258.857-105.714-138.286 168.571q-10.286 13.143-28 13.143-7.429 " +
                        "0-12.571-2.286-10.857-4-17.429-13.429t-6.571-20.857v-199.429l493.714-605.143-610.857 " +
                        "528.571-225.714-92.571q-21.143-8-22.857-31.429-1.143-22.857 18.286-33.714l950.857-548.571q8.571-5.143 18.286-5.143 " +
                        "11.429 0 20.571 6.286z";

        public static final String viewSvg =
                "M320.06 255.58m28 0l328.07 0q28 0 28 28l0 0q0 28-28 28l-328.07 0q-28 0-28-28l0 0q0-28 28-28Z " +
                        "M320.06 420.21m28 0l200.42 0q28 0 28 28l0 0q0 28-28 28l-200.42 0q-28 0-28-28l0 0q0-28 28-28Z " +
                        "M888.35 320h-56.19V135.61a72 72 0 0 0-72-72H264a72 72 0 0 0-72 72V320h-55.79a72 72 0 0 0-72 72v496.22a72 72 0 0 0 72 72h752.14a72 72 0 0 0 72-72V392a72 72 0 0 0-72-72z m0 72v47.59c-0.53 0.27-1.05 0.56-1.57 0.86L832.16 472v-80zM264 135.61h496.16v377l-151.33 88.31-96.55 55.74L264 513.33V135.61zM192 392v79.77l-55.83-32.24V392z m-55.79 496.22V522.67l56.2 32.45 298 173A43 43 0 0 0 502 732.7a35.88 35.88 0 0 0 9.52 1.51h1.61a35.58 35.58 0 0 0 11.65-2.21 42.58 42.58 0 0 0 9-3.94L645 663.17l243.35-140.5v365.55z";
    }
}
