package net.lensfrex.disillusion.client.controller.components.employer.offer;

import cn.hutool.core.util.RandomUtil;
import com.jfoenix.controls.JFXTextArea;
import com.jfoenix.controls.JFXTextField;
import javafx.fxml.FXML;
import javafx.scene.layout.VBox;
import net.lensfrex.disillusion.client.config.Constants;
import net.lensfrex.disillusion.client.data.request.OfferPublishRequest;
import net.lensfrex.disillusion.client.data.response.OfferResponse;

public class EmployerOfferDetailPane extends VBox {
    @FXML
    private VBox rootPane;

    @FXML
    private JFXTextField jobNameTextField;

    @FXML
    private JFXTextField salaryTextField;

    @FXML
    private JFXTextField planNumberTextField;

    @FXML
    private JFXTextField placeTextField;

    @FXML
    private JFXTextField requirementTextField;

    @FXML
    private JFXTextArea detailTextArea;

    private OfferResponse offer;

    // 无参构造方法，勿删
    public EmployerOfferDetailPane() {
    }

    public EmployerOfferDetailPane(OfferResponse offer) {
        this.offer = offer;
    }

    public void initialize() {
        if (offer == null) {
            jobNameTextField.setText(RandomUtil.randomString(Constants.sample, RandomUtil.randomInt(3, 5)));
            placeTextField.setText(RandomUtil.randomString(Constants.sample, RandomUtil.randomInt(3, 5)));
            requirementTextField.setText(RandomUtil.randomString(Constants.sample, RandomUtil.randomInt(5, 10)));
            salaryTextField.setText(RandomUtil.randomNumbers(5));
            planNumberTextField.setText(RandomUtil.randomNumbers(2));
            detailTextArea.setText(RandomUtil.randomString(Constants.sample, RandomUtil.randomInt(300, 700)));
            return;
        }

        String jobName = offer.getJobName();
        String place = offer.getPlace();
        String requirement = offer.getRequirement();
        Integer salary = offer.getSalary();
        Integer targetNumber = offer.getTargetNumber();
        String detail = offer.getDetail();

        jobNameTextField.setText(jobName);
        placeTextField.setText(place);
        requirementTextField.setText(requirement);
        salaryTextField.setText(salary.toString());
        planNumberTextField.setText(targetNumber.toString());
        detailTextArea.setText(detail);
    }

    public OfferPublishRequest getData() {
        OfferPublishRequest request = new OfferPublishRequest();
        request.setJobName(jobNameTextField.getText());
        request.setPlace(placeTextField.getText());
        request.setRequirement(requirementTextField.getText());
        request.setDetail(detailTextArea.getText());

        String targetNumberText = planNumberTextField.getText();
        if (!targetNumberText.matches(Constants.numberPattern)) {
            request.setTargetNumber(-1);
        } else {
            request.setTargetNumber(Integer.parseInt(targetNumberText));
        }

        String salaryText = salaryTextField.getText();
        if (!salaryText.matches(Constants.numberPattern)) {
            request.setSalary(-1);
        } else {
            request.setSalary(Integer.parseInt(salaryText));
        }

        return request;
    }
}
