package net.lensfrex.disillusion.client.util;

import com.jfoenix.controls.JFXButton;
import com.jfoenix.controls.events.JFXDialogEvent;
import javafx.application.Platform;
import javafx.beans.NamedArg;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.scene.Node;
import javafx.scene.layout.Pane;

public class ThreadSafeDialogMaker extends DialogMaker {
    public ThreadSafeDialogMaker(@NamedArg("rootPane") Pane rootPane) {
        super(rootPane);
    }

    public void createMessageDialog(@NamedArg("title") String title, @NamedArg("message") String message) {
        Platform.runLater(() -> super.createMessageDialog(title, message));
    }

    //创建只有一个按钮的dialog
    public void createDialogWithOneBtn(@NamedArg("title") String title, @NamedArg("theBody") Node body, @NamedArg("OKEvent") EventHandler<ActionEvent> event) {
        Platform.runLater(() -> super.createDialogWithOneBtn(title, body, event));
    }

    public void createDialogWithOneBtn(@NamedArg("title") String title, @NamedArg("theBody") Node body) {
        createDialogWithOneBtn(title, body, null);
    }

    //创建有OK和cancel按钮的dialog
    public void createDialogWithOKAndCancel(@NamedArg("title") String title, @NamedArg("message") String message, @NamedArg("OKEvent") EventHandler<ActionEvent> OKEvent) {
        Platform.runLater(() -> super.createDialogWithOKAndCancel(title, message, OKEvent));
    }

    //创建有OK和cancel按钮的dialog
    public void createDialogWithOKAndCancel(@NamedArg("title") String title, @NamedArg("body") Node body, @NamedArg("OKEvent") EventHandler<ActionEvent> OKEvent) {
        Platform.runLater(() -> super.createDialogWithOKAndCancel(title, body, OKEvent));
    }

    public void createDialog(@NamedArg("title") String title, @NamedArg("theBody") Node body, @NamedArg("buttons") JFXButton... buttons) {
        Platform.runLater(() -> super.createDialog(title, body, buttons));
    }
}
