package net.lensfrex.disillusion.web.service.user;

import net.lensfrex.disillusion.dao.UserInfoTable;
import net.lensfrex.disillusion.data.ArrayList;
import net.lensfrex.disillusion.data.List;
import net.lensfrex.disillusion.model.UserInfo;
import net.lensfrex.disillusion.model.employer.Employer;
import org.springframework.stereotype.Service;

import java.io.IOException;

@Service
public class UserInfoService {
    private final UserInfoTable userInfoTable;

    public UserInfoService(UserInfoTable userInfoTable) {
        this.userInfoTable = userInfoTable;
    }

    public UserInfo getUserInfoById(String id) throws IOException, ClassNotFoundException {
        return userInfoTable.select(id);
    }

    public List<Employer> getAllEmployerUserInfo() throws IOException, ClassNotFoundException {
        List<UserInfo> allUserInfo =  userInfoTable.getAll();
        List<Employer> employers = new ArrayList<>(allUserInfo.size());

        for (int i = 0; i < allUserInfo.size(); i++) {
            UserInfo userInfo = allUserInfo.get(i);
            if (userInfo instanceof Employer employer) {
                employers.add(employer);
            }
        }

        return employers;
    }

    public void saveUserInfoById(UserInfo userInfo) throws IOException, ClassNotFoundException {
        userInfoTable.insertOrUpdate(userInfo);
    }
}
