package net.lensfrex.disillusion.web.service.user;

import net.lensfrex.disillusion.dao.UserTable;
import net.lensfrex.disillusion.data.List;
import net.lensfrex.disillusion.model.User;
import org.mindrot.jbcrypt.BCrypt;
import org.springframework.stereotype.Service;

import java.io.IOException;

@Service
public class UserService {
    private final UserTable userTable;

    public UserService(UserTable userTable) {
        this.userTable = userTable;
    }

    public User getAccount(String username) throws IOException, ClassNotFoundException {
        return userTable.select(username);
    }

    public List<User> getAllUser() throws IOException, ClassNotFoundException {
        return userTable.getAll();
    }

    public void registerNewUser(String username, String password, User.UserType userType) throws IOException, ClassNotFoundException {
        String hashedPassword = BCrypt.hashpw(password, BCrypt.gensalt());
        User newUser = new User(userType, username, hashedPassword);
        userTable.insertOrUpdate(newUser);
    }

    public void updateUser(User user) throws IOException, ClassNotFoundException {
        userTable.insertOrUpdate(user);
    }
}
