package net.lensfrex.disillusion.data.db;

import net.lensfrex.disillusion.data.ArrayList;
import net.lensfrex.disillusion.data.Hash;

public class Table {
    private final ArrayList<Hash<String, String>> page;
    private final ArrayList<String> keys;

    private final Hash<String, Integer> primaryKeyIndex = new Hash<>();

    private final Hash<String, String> index = new Hash<>();
    private final ArrayList<String> indexKeys;

    public Table(String[] fields, String... indexFields) {
        this.page = new ArrayList<>();
        this.keys = new ArrayList<>();
        for (String field : fields) {
            keys.add(field);
        }

        indexKeys= new ArrayList<>(indexFields.length);
        for (String indexField : indexFields) {
            indexKeys.add(indexField);
        }
    }

    public void insert(String[] fields, String[] value) {
        Hash<String, String> record = new Hash<>();
        for (int i = 0; i < fields.length; i++) {
            if (!keys.contains(fields[i])) {
                throw new IllegalArgumentException("Field '%s' doesn't exist.");
            }

            record.put(fields[i], value[i]);
        }

        primaryKeyIndex.put(fields[1], page.size());
    }
}
