package net.lensfrex.disillusion.model;

import lombok.Data;
import net.lensfrex.disillusion.data.ArrayList;

/**
 * 哈希一对多索引，用于对取值不唯一的字段的查询
 */
@Data
public class MultiIndex implements StoreData {
    private final String key;
    private final ArrayList<String> values;

    public MultiIndex(String key) {
        this.key = key;
        this.values = new ArrayList<>(8);
    }

    public void addValue(String value) {
        values.add(value);
    }

    public String[] getAllValues() {
        return values.toArray(new String[values.size()]);
    }

    public void removeValue(Object target) {
        values.remove(target);
    }

    public boolean hasValue(Object obj) {
        return values.contains(obj);
    }

    @Override
    public String getId() {
        return key;
    }

    @Override
    public void setId(String id) {

    }
}