package net.lensfrex.disillusion.model;

import lombok.Data;

import java.io.Serializable;
import java.util.Objects;

@Data
public class User implements Serializable, StoreData {
    private UserType userType;

    private final String username;
    private final String password;

    public enum UserType {
        STUDENT(0, "学生"),
        EMPLOYER(1, "用人单位"),
        ;

        public final int code;
        public final String name;

        UserType(int code, String name) {
            this.code = code;
            this.name = name;
        }
    }

    public User(UserType userType, String username, String password) {
        if (username == null) {
            throw new NullPointerException("Field 'username' can't be null");
        }

        this.userType = userType;
        this.username = username;
        this.password = password;
    }

    @Override
    public String getId() {
        return username;
    }

    @Override
    public void setId(String id) {

    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        User user = (User) o;
        return username.equals(user.username);
    }

    @Override
    public int hashCode() {
        return Objects.hash(username);
    }
}