package net.lensfrex.disillusion.model.employer;

import lombok.Data;
import net.lensfrex.disillusion.model.UserInfo;
import net.lensfrex.disillusion.model.StoreData;
import net.lensfrex.disillusion.model.student.Student;

import java.io.Serializable;
import java.util.Objects;

/**
 * 用人单位信息
 */
@Data
public class Employer implements UserInfo, Serializable, StoreData {
    private String id;

    /**
     * 公司名称
     */
    private String name;

    /**
     * 总部地址
     */
    private String place;

    /**
     * 联系方式
     */
    private String contract;

    /**
     * 公司简要介绍
     */
    private String shortDescribe;

    /**
     * 公司介绍
     */
    private String describe;

    /**
     * 所属行业
     */
    private String industry;

    public static Employer getDefaultInfo(String id) {
        Employer employer = new Employer();
        employer.setId(id);
        employer.setName("不知道是什么公司");
        employer.setPlace("不知道公司在哪里");
        employer.setShortDescribe("简短的介绍");
        employer.setDescribe("还没有什么描述呢");
        employer.setContract("400-1010101010");
        employer.setIndustry("不知道是什么行业");

        return employer;
    }
}
