package net.lensfrex.disillusion.model.employer;

import lombok.Data;
import net.lensfrex.disillusion.model.StoreData;

import java.io.Serializable;
import java.util.Objects;

/**
 * 招聘信息
 */
@Data
public class Offer implements Serializable, StoreData {
    private String id;

    /**
     * 发布公司
     */
    private String publisherId;

    /**
     * 岗位名称
     */
    private String jobName;

    /**
     * 工作地点
     */
    private String place;

    /**
     * 要求
     */
    private String requirement;

    /**
     * 预期薪资
     */
    private Integer salary;

    /**
     * 目标人数
     */
    private Integer targetNumber;

    /**
     * 详细信息
     */
    private String detail;

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Offer offer = (Offer) o;
        return id.equals(offer.id);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id);
    }
}
