package net.lensfrex.disillusion.model.student;

import lombok.Data;
import net.lensfrex.disillusion.model.UserInfo;
import net.lensfrex.disillusion.model.StoreData;
import net.lensfrex.disillusion.util.IOUtil;

import java.io.Serializable;
import java.nio.charset.StandardCharsets;

@Data
public class Student implements UserInfo, Serializable, StoreData {
    private String id;

    /**
     * 真名
     */
    private String realName;

    /**
     * 简介
     */
    private String shortDescribe;

    /**
     * 介绍
     */
    private String describe;

    /**
     * 电话号
     */
    private String phoneNumber;

    /**
     * 身份证号
     */
    private String idNumber;

    /**
     * 年龄
     */
    private int age;

    /**
     * 性别，0：男；1：女
     */
    private int sex;

    public static final byte[] DEFAULT_AVATAR = IOUtil.readDataFromInputStream(
            Student.class.getResourceAsStream("/61212844_p0_compress.png"));

    public static Student getDefaultInfo(String username) {
        Student student = new Student();
        student.setId(username);
        student.setRealName(username);
        student.setShortDescribe("这个人很懒什么都没写");
        student.setDescribe("没有简介...");
        student.setPhoneNumber("没有填写");
        student.setIdNumber("没有提供");
        student.setAge(22);
        student.setSex(0);

        return student;
    }
}
