/*
 * Class created by lensfrex.
 */

package net.lensfrex.disillusion.response.general;

import cn.hutool.json.JSONUtil;

import java.nio.charset.StandardCharsets;

public record Response<T>(int code, String message, T data) {

    public static <T> Response<T> success(T data) {
        return new Response<>(ResponseCode.SUCCESS.getCode(), "success", data);
    }

    public static <T> Response<T> success() {
        return success(null);
    }

    public static <T> Response<T> error(ResponseCode code, String message) {
        return new Response<>(code.getCode(), message, null);
    }

    public static <T> Response<T> error(ResponseCode code) {
        return error(code, code.getMessage());
    }

    public byte[] toBytes() {
        return JSONUtil.toJsonStr(this).getBytes(StandardCharsets.UTF_8);
    }
}