/*
 * Class created by lensfrex.
 */

package net.lensfrex.disillusion.response.general;

public enum ResponseCode {
    SUCCESS(20000, "成功"),
    REQUEST_TOO_FAST(20001, "技能冷却中..."),

    INVALID_REQUEST(30000, "非法请求"),
    PARAM_WRONG(30001, "参数错误"),

    PERMISSION_DENIED(40000, "权限不足"),
    TOKEN_EXPIRED(40001, "token过期"),
    TOKEN_INVALID(40002, "token无效"),

    IDENTIFY_ERROR(40100, "用户不存在或密码错误"),
    USER_ALREADY_EXISTS(40101, "用户名已经被注册"),

    USER_NOT_EXISTS(40103, "用户不存在"),

    SERVER_INTERNAL_ERROR(50000, "服务器内部错误"),

    API_NOT_IMPLEMENT(0, "接口未实现"),

    REQUEST_FILE_DOES_NOT_EXIST(60701, "请求的文件不存在");

    private final int code;

    private final String message;

    ResponseCode(int code, String message) {
        this.code = code;
        this.message = message;
    }

    public int getCode() {
        return code;
    }

    public String getMessage() {
        return message;
    }
}
